/***********************************************************
 * $Id: RemoteInvocationFailureException.java 66 2009-04-30 13:47:14Z wglas $
 * 
 * remoting framework of the clazzes project.
 * http://www.clazzes.org
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 *
 * Created: 29.04.2009
 * 
 ***********************************************************/

package org.clazzes.remoting;

/**
 * This exception is thrown whenever a remote invocation fails due to an invalid
 * command being received on the wire. 
 * 
 * @author wglas
 */
public class RemoteInvocationFailureException extends RuntimeException {

    private static final long serialVersionUID = -1027764732894686603L;

    public RemoteInvocationFailureException() {
    }

    public RemoteInvocationFailureException(String message) {
        super(message);
    }

   public RemoteInvocationFailureException(Throwable cause) {
        super(cause);
    }

   public RemoteInvocationFailureException(String message, Throwable cause) {
        super(message, cause);
    }

}
