/***********************************************************
 * $Id: CallbackWrapper.java 66 2009-04-30 13:47:14Z wglas $
 * 
 * remoting framework of the clazzes project.
 * http://www.clazzes.org
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 *
 * Created: 29.04.2009
 * 
 ***********************************************************/

package org.clazzes.remoting.beans;

import org.clazzes.remoting.InvocationHandler;

/**
 * A facility, which wraps a client-side object with a callback invocation handler.
 * 
 * @author wglas
 */
public interface CallbackWrapper {

	/**
	 * @return The interface handled by this callback handler.
	 */
	public Class<?> getServiceInterface();
	
	/**
	 * @param target The target object to be called, which has to implement
	 *               the interface returned by {@link #getServiceInterface()}.
	 * @return A handler, which delegates callback to the given object.
	 */
	public InvocationHandler getWrapper(Object target);
	
	
}
