/***********************************************************
 * $Id: SessionAuthenticator.java 66 2009-04-30 13:47:14Z wglas $
 * 
 * remoting framework of the clazzes project.
 * http://www.clazzes.org
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 *
 * Created: 29.04.2009
 * 
 ***********************************************************/

package org.clazzes.remoting.beans;

import java.rmi.server.UID;
import java.util.Map;

import org.clazzes.remoting.client.Client;

/**
 * Implementations of this interface are responsible for creating authentication
 * credentials for recognition of a corresponding {@link BeanCallAuthManager} on
 * the server.  
 * 
 * @author wglas
 */
public interface SessionAuthenticator {

	/**
	 * @param sessionId The client session ID as returned by {@link Client#getSessionId()}.
	 * @return A Map containing the metadata to be attached to the invocation request.
	 */
	Map<String,Object> createCredentials(UID sessionId);
}
