/***********************************************************
 * $Id: InvocationExceptionCmd.java 5 2008-10-15 20:38:35Z wglas $
 * 
 * remoting framework of the clazzes project.
 * http://www.clazzes.org
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 *
 * Created: 15.10.2008
 * 
 ***********************************************************/

package org.clazzes.remoting.cmd;


/**
 * A command that is sent, when an invocation raised an exception.
 * 
 * @author wglas
 */
public class InvocationExceptionCmd extends Cmd {

    private static final long serialVersionUID = -6565844600425860788L;

    private final Throwable exception;

    /**
     * @param excpetion The exception raised by an invocation.
     */
    public InvocationExceptionCmd(Throwable excpetion) {
        super();
        this.exception = excpetion;
    }

    /**
     * @return The result of an invocation.
     */
    public Throwable getException() {
        return this.exception;
    }

    /* (non-Javadoc)
     * @see org.clazzes.remoting.cmd.Cmd#accept(org.clazzes.remoting.cmd.CmdVisitor)
     */
    @Override
    public void accept(CmdVisitor visitor) {
       
        visitor.visit(this);
    }
}
