/***********************************************************
 * $Id: LoadClassCmd.java 7 2008-10-16 20:35:10Z wglas $
 * 
 * remoting framework of the clazzes project.
 * http://www.clazzes.org
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 *
 * Created: 15.10.2008
 * 
 ***********************************************************/

package org.clazzes.remoting.cmd;


/**
 * A command that requires a remote class being loaded.
 * 
 * @author wglas
 */
public class LoadClassCmd extends Cmd {

    private static final long serialVersionUID = 3347217843399443299L;

    private final String className;
    
    /**
     * @param className The name of the class being loaded.
     */
    public LoadClassCmd(String className) {
        
        super();
        this.className = className;
    }

    /**
     * @return The subsystem being called.
     */
    public String getClassName() {
        return this.className;
    }

    /* (non-Javadoc)
     * @see org.clazzes.remoting.cmd.Cmd#accept(org.clazzes.remoting.cmd.CmdVisitor)
     */
    @Override
    public void accept(CmdVisitor visitor) {
       
        visitor.visit(this);
    }
}
