/***********************************************************
 * $Id: LinkedHashMapObjectMarshaler.java 150 2009-10-12 18:52:25Z wglas $
 * 
 * remoting framework of the clazzes project.
 * http://www.clazzes.org
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 *
 * Created: 23.08.2009
 * 
 ***********************************************************/

package org.clazzes.remoting.marshal.impl;

import java.io.IOException;
import java.lang.reflect.Method;
import java.util.LinkedHashMap;
import java.util.Map;

/**
 * Marshal a {@link LinkedHashMap} instance.
 */
public class LinkedHashMapObjectMarshaler implements ObjectMarshaler {

    /* (non-Javadoc)
     * @see org.clazzes.remoting.marshal.impl.ObjectMarshaler#getReadResolveMethod()
     */
    public Method getReadResolveMethod() {
        
        return null;
    }

    /* (non-Javadoc)
     * @see org.clazzes.remoting.marshal.impl.ObjectMarshaler#getWriteReplaceMethod()
     */
    public Method getWriteReplaceMethod() {
        
        return null;
    }

    /* (non-Javadoc)
     * @see org.clazzes.remoting.marshal.impl.ObjectMarshaler#readObject(org.clazzes.remoting.marshal.impl.CompactMarshaler, long, org.clazzes.remoting.marshal.impl.ClassInfo)
     */
    public Object readObject(CompactMarshaler context, long ref, ClassInfo ci)
            throws IllegalArgumentException, IllegalAccessException,
            IOException, ClassNotFoundException {
       
        
        int n = context.getDataInputStream().readInt();

        LinkedHashMap<Object, Object> map = new LinkedHashMap<Object, Object>(n);
        context.cacheReadPremature(ref,map);
        
        for (int i=0;i<n;++i) {
            
            Object key = ObjectFieldMarshaler.readObject(context);
            Object value = ObjectFieldMarshaler.readObject(context);
            
            map.put(key,value);
        }
        
        return map;
    }

    /* (non-Javadoc)
     * @see org.clazzes.remoting.marshal.impl.ObjectMarshaler#writeObject(org.clazzes.remoting.marshal.impl.CompactMarshaler, java.lang.Object)
     */
    public void writeObject(CompactMarshaler context, Object obj)
            throws IllegalArgumentException, IOException,
            IllegalAccessException, ClassNotFoundException {
        
        Map<?,?> map = (Map<?, ?>) obj;
        context.getDataOutputStream().writeInt(map.size());
        
        for (Map.Entry<?,?> entry:map.entrySet()) {
    
            ObjectFieldMarshaler.writeObject(context,entry.getKey());
            ObjectFieldMarshaler.writeObject(context,entry.getValue());
        }
    }

}
