/***********************************************************
 * $Id: TreeSetObjectMarshaler.java 150 2009-10-12 18:52:25Z wglas $
 * 
 * remoting framework of the clazzes project.
 * http://www.clazzes.org
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 *
 * Created: 23.08.2009
 * 
 ***********************************************************/

package org.clazzes.remoting.marshal.impl;

import java.io.IOException;
import java.lang.reflect.Method;
import java.util.Comparator;
import java.util.TreeMap;
import java.util.TreeSet;

/**
 * Marshal a {@link TreeMap} instance.
 */
public class TreeSetObjectMarshaler implements ObjectMarshaler {

    /* (non-Javadoc)
     * @see org.clazzes.remoting.marshal.impl.ObjectMarshaler#getReadResolveMethod()
     */
    public Method getReadResolveMethod() {
        
        return null;
    }

    /* (non-Javadoc)
     * @see org.clazzes.remoting.marshal.impl.ObjectMarshaler#getWriteReplaceMethod()
     */
    public Method getWriteReplaceMethod() {
        
        return null;
    }

    /* (non-Javadoc)
     * @see org.clazzes.remoting.marshal.impl.ObjectMarshaler#readObject(org.clazzes.remoting.marshal.impl.CompactMarshaler, long, org.clazzes.remoting.marshal.impl.ClassInfo)
     */
    @SuppressWarnings("unchecked")
    public Object readObject(CompactMarshaler context, long ref, ClassInfo ci)
            throws IllegalArgumentException, IllegalAccessException,
            IOException, ClassNotFoundException {
        
        Comparator cmp = (Comparator)ObjectFieldMarshaler.readObject(context);
        
        TreeSet<Object> set = new TreeSet<Object>(cmp);
        
        context.cacheReadPremature(ref,set);
        
        int n = context.getDataInputStream().readInt();
        
        for (int i=0;i<n;++i) {
            
            Object value = ObjectFieldMarshaler.readObject(context);
            
            set.add(value);
        }
        
        return set;
    }

    /* (non-Javadoc)
     * @see org.clazzes.remoting.marshal.impl.ObjectMarshaler#writeObject(org.clazzes.remoting.marshal.impl.CompactMarshaler, java.lang.Object)
     */
    public void writeObject(CompactMarshaler context, Object obj)
            throws IllegalArgumentException, IOException,
            IllegalAccessException, ClassNotFoundException {
        
        TreeSet<?> set = (TreeSet<?>) obj;
        
        ObjectFieldMarshaler.writeObject(context,set.comparator());
        
        context.getDataOutputStream().writeInt(set.size());
        
        for (Object v:set) {
    
            ObjectFieldMarshaler.writeObject(context,v);
        }
    }

}
