/***********************************************************
 * $Id: SocketMetaData.java 63 2009-04-26 18:21:35Z wglas $
 * 
 * remoting framework of the clazzes project.
 * http://www.clazzes.org
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 *
 * Created: 16.04.2009
 * 
 ***********************************************************/

package org.clazzes.remoting.transport;

import java.net.Socket;
import java.net.SocketAddress;

import javax.net.ssl.SSLSession;

import org.clazzes.remoting.InvocationHandler;

/**
 * This interface holds the standard property names under which the socket
 * information is made available to
 * {@link InvocationHandler#invoke(org.clazzes.remoting.InvocationContext, Object, java.util.Map)}
 * as part of the meta data argument.  
 * 
 * @author wglas
 */
public interface SocketMetaData {

    /**
     * The result of {@link Socket#getRemoteSocketAddress()}, which is of type
     * {@link SocketAddress}.
     */
    public static final String PEER_ADDRESS = "org.clazzes.remoting::PeerAddress";
    
    /**
     * The key under which the {@link SSLSession} is made accessible to the
     * application layer, if the client is connected through an SSL Socket. 
     */
    public static final String SSL_SESSION = "org.clazzes.remoting::SSLSession";
    
}
